#include <stdio.h>
#include <conio.h>
#include <direct.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <share.h>
#include <malloc.h>
#include <process.h>
#include <time.h>
#include <windows.h>
#include <commdlg.h>
#define BUFSIZE 64000
SYSTEMTIME startnow,endnow,start1,end1;
long minsize=0;

/*
XFER32 -- Determine how fast data can be transferred from a hard drive or network.
    Copyright (C) 2003  Norm London, London Computing

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	norm_london@londoncomputing.com

    Compile with Visual Studio 6 or later.  Requires comdlg32.lib odbc32.lib odbccp32.lib winmm.lib
	cl xfer32.c /link comdlg32.lib odbc32.lib odbccp32.lib winmm.lib

*/

char *comma_delim(_int64 lno,char *buffer,char mb,char kb) {
/* returns the long integer in comma delimited format */
/* Assume buffer is long enough to hold the largest value */
/* mb = 1; return result in MB; kb = 1 return result in KB */
	char b1[36],*b; /* should be long enough to hold largest ltoa value */
	int i,n,l,k,c;
	_int64 no;
	no = lno;
	if (mb) {
		no = (lno / (1024*1024));
		if (no > -1.0 && no < 1.0) {
			kb = 1;
			mb = 0;
		}
	}

	if (kb) {
		no = (lno / 1024);
		if (no > -1.0 && no < 1.0) {
			no = lno;
			kb = 0;
		}
	}

	sprintf(b1,"%16.0f",(long double)no);
	for (b=b1;*b==' ';++b) ;  // Remove leading blanks

	l = strlen(b); /* l is length of string and index to 0 at end of string */
	n = l/3;	   /* n is number of commas to be inserted */
	if ((l % 3) == 0)
		--n;
	k = l + n;	   /* k is length of new string */
	buffer[k--] = b[l--];
	for (c=0,i=l; i >= 0; --i,--k) {
		buffer[k] = b[i];
		if (++c == 3 && i > 0) {
			buffer[--k] = ',';
			c = 0;
		}
	}

	if (mb)
		strcat(buffer,"MB");
	else if (kb)
		strcat(buffer,"KB");

	return buffer;
}

char *tgm(long double val,char *valstr) {
	// reformat number so that it looks like xxx.xT. xxx.xM. xxx.xK. xxx.x
	long double oneT =   1000000000000.;
	long double oneG =   1000000000.;
	long double oneM =   1000000;
	long double oneK =   1000;
	if (val >= oneT) 
		sprintf(valstr,"%.1lfT",val/oneT);
	else if (val >= oneG)
		sprintf(valstr,"%.1lfG",val/oneG);
	else if (val >= oneM)
		sprintf(valstr,"%.1lfM",val/oneM);
	else if (val>= oneK)
		sprintf(valstr,"%.1lfK",val/oneK);
	else
		sprintf(valstr,"%.1f",val);
	return valstr;
}


void rest_a_bit(DWORD elapsed, int si, long rate) {
	double desired;
	// Calculate the desired number of milliseconds that
	// this read should have taken
	desired = (1000. *(double)si) / (double) rate;
	//read rate in KB/ sec is higher than desired
	//calculate a wait period to force it down
	if ((unsigned long)desired > elapsed)
		Sleep((long)desired - elapsed + 1);
}
void DisplayCommonDialogError(DWORD ErrorCode) {
	switch(ErrorCode) {
		case 0:	
			fprintf(stderr,"Cancelled.\n"); 
			break;
		case CDERR_DIALOGFAILURE:
			fprintf(stderr,"Dialog Failure.\n");
			break;
		case CDERR_FINDRESFAILURE:
			fprintf(stderr,"Resource Missing.\n");
			break;
		case CDERR_INITIALIZATION:
			fprintf(stderr,"Initialization Failure. Possible Insufficient Memory.\n");
			break;
		case CDERR_LOADRESFAILURE:
			fprintf(stderr,"Unable to load resource.\n");
			break;
		case CDERR_LOADSTRFAILURE:
			fprintf(stderr,"Unable to load string.\n");
			break;
		case CDERR_LOCKRESFAILURE:
			fprintf(stderr,"Unable to lock resource.\n");
			break;
		case CDERR_MEMALLOCFAILURE:
			fprintf(stderr,"Insufficient memory.\n");
			break;
		case CDERR_MEMLOCKFAILURE:
			fprintf(stderr,"Unable to lock memory.\n");
			break;
		case CDERR_NOHINSTANCE:
			fprintf(stderr,"The ENABLETEMPLATE flag was set in the Flags member\n");
			fprintf(stderr,"of the initialization structure for the corresponding\n");
			fprintf(stderr,"common dialog box, but corresponding instance handle missing.\n");
			break;
		case CDERR_NOHOOK:
			fprintf(stderr,"Enable Hook Specified, but HOOK procedure missing.\n");
			break;
		case CDERR_NOTEMPLATE:
			fprintf(stderr,"Enable Template Specified, but TEMPLATE missing.\n");
			break;
		case CDERR_REGISTERMSGFAIL:
			fprintf(stderr, "Register Message Call failed.\n");
			break;
		case CDERR_STRUCTSIZE:
			fprintf(stderr, "The lStructSize member of the initialization structure for the corresponding common dialog box is invalid.\n");
			break;
		case FNERR_BUFFERTOOSMALL:
			fprintf(stderr, "Buffer too small to hold filename.\n");
			break;
		case FNERR_INVALIDFILENAME:
			fprintf(stderr, "Invalid Filename.\n");
			break;
		case FNERR_SUBCLASSFAILURE:
			fprintf(stderr, "An attempt to subclass a list box failed because sufficient memory was not available.\n");
			break;
		default:
			fprintf(stderr, "Error %d returned from Dialog Box.\n", ErrorCode);
			break;
	}
}

void Usage(FILE *hlp, char *path) {
	char cmd[2048];
		fprintf(hlp,"XFER32 Version 1.23, %s\n",__DATE__);
		fprintf(hlp,"\nCopyright 2003, Norm London, London Computing.\nnorm_london@londoncomputing.com\n\n");
        fprintf(hlp,"This program is free software; you can redistribute it and/or modify\n");
		fprintf(hlp,"it under the terms of the GNU General Public License as published by\n");
		fprintf(hlp,"the Free Software Foundation; either version 2 of the License, or\n");
		fprintf(hlp,"(at your option) any later version.\n\n");
		fprintf(hlp,"This program is distributed in the hope that it will be useful,\n");
		fprintf(hlp,"but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
		fprintf(hlp,"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
		fprintf(hlp,"GNU General Public License for more details.\n\n");
		fprintf(hlp,"You should have received a copy of the GNU General Public License\n");
		fprintf(hlp,"along with this program; if not, write to the Free Software\n");
		fprintf(hlp,"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n\n");
		fprintf(hlp,"Usage is:\nXFER32 [-q] [-c] [-snnn] filename [bufsize [errorkt [readKB [rateKB [ratedist]]]]]\n");
		fprintf(hlp,"XFER32 reads a file and displays the bytes read per second.\n");
		fprintf(hlp,"It can be used to determine how fast a drive or lan connection is or to\n");
		fprintf(hlp,"force READ activity on a machine.  By default, XFER32 opens the file \n");
		fprintf(hlp,"with no buffering to ensure consistent transfer rates.  Files on CDROMS\n");
		fprintf(hlp,"are always opened with buffering turned on.\n\n");
		fprintf(hlp,"filename is the name of the file to be read.\n");
		fprintf(hlp,"filename should be at least 32KB in size.\n\n");
		fprintf(hlp,"If the filename points to a directory and the -snnn parameter is specified, \n");
		fprintf(hlp,"XFER32 will use the first file it finds on drive d: that is at least\n");
		fprintf(hlp,"nnn Bytes.  This option requires that the program SEARCH32 be in the \n");
		fprintf(hlp,"same directory as XFER32 or is in one of the directories specified.\n");
		fprintf(hlp,"in the PATH.\n\n");
		fprintf(hlp,"If the filename points to a directory and -s has not been specified,\n");
		fprintf(hlp,"a file open dialog will display starting at the directory specified.\n\n");
		fprintf(hlp,"If the filename is invalid (e.g. *), a file open dialog will display.\n\n");
		fprintf(hlp,"bufsize is the size of the read buffer in Bytes.  64 <= bufsize <= 65535\n");
		fprintf(hlp,"-OR- the size of the read buffer in KiloBytes.     1 <= bufsize <  63\n");
		fprintf(hlp,"if bufsize omitted, 64000 is used.\n");
		fprintf(hlp,"errorkt is the number of read errors to ignore before quitting, default 0\n");
		fprintf(hlp,"readKB is the number of KB to read for this request.\n");
		fprintf(hlp,"       If omitted or <= 0, entire file is read.\n");
		fprintf(hlp,"rateKB is the number of KB to read per second.  Default, Full Speed.\n");
		fprintf(hlp,"dist forces the rateKB to be a random number between rateKB-dist to rateKB+dist.\n");
		fprintf(hlp,"\nThe output of XFER32 shows a continuous display of the number.\n");
		fprintf(hlp,"Size (bytes read), Time (in seconds), Xfer Rate (Transfer Rate).\n");
		fprintf(hlp,"Xfer32 may also report on:\n");
		fprintf(hlp,"Short Blks  (Number of reads returning less than the block size.)\n");
		fprintf(hlp,"             One short block is normal when the file size is not\n");
		fprintf(hlp,"             a multiple of the block size and will not be reported.\n");
		fprintf(hlp,"             Short blocks are most prevalent on slow LAN links where\n");
		fprintf(hlp,"             a timeout occurs before the entire block is read.\n");
		fprintf(hlp,"Error Count (Number of reads returning errors.\n");
		fprintf(hlp,"-q -- Quiet Mode.  Do display statistics every second.\n");
		fprintf(hlp,"-c -- Cache Mode.  Allow Windows 95, 98, NT or 2000 to cache the file.\n");
		fclose(hlp);
		strcpy(cmd,"NOTEPAD.EXE ");
		strcat(cmd,path);
		WinExec(cmd,SW_SHOW);
		exit(1);
}

void main(int argc,char *argv[]) {
	time_t start,stop,prev;
	int cache = FILE_FLAG_NO_BUFFERING;
	DWORD t0,t1,startopen,opentime;
	_int64 size,bytes,readKB=0;
	long rateKB=0, ratedist=0;
	unsigned si,bufsi;
	int driveType, rc;
	char *buffer,thyme[4],more,temp_bps[64],temp_size[64], debugbuf[256];
	HANDLE in;
	int arg,quiet=0;
	long double bps;
	FILE *hlp;
	int error_count = 0, max_errors = 0, short_blocks = 0;
	#ifdef WIN32
	char tmp[_MAX_PATH],*p,cmd[_MAX_PATH];
	OPENFILENAME ofn;       // common dialog box structure
	char szFile[_MAX_PATH] = {0};       // buffer for file name
	HWND hwnd = NULL;              // owner window
	BOOL CommonDialogError;
	char tempfiletemplate[64];
	DWORD CommonDialogErrorCode;
	struct _stati64 statbuf;
	char inputfile[_MAX_PATH],fn[_MAX_PATH],cmdline[1024];
	FILE *fi;

	if ((p=getenv("tmp")) == NULL)
		if ((p = getenv("temp")) == NULL)
			GetWindowsDirectory(tmp,_MAX_PATH);
		else
			strcpy(tmp,p);
	else
		strcpy(tmp,p);
	if (tmp[strlen(tmp)-1] != '\\')
		strcat(tmp,"\\");

	strcat(tmp,"xfer32.hlp");
	hlp = fopen(tmp,"w");
#else
	hlp = stderr;
#endif

	if (argc < 2) 
		Usage(hlp,tmp);
	
	arg = 0;
	while ((arg+1) < argc && argv[arg+1][0] == '-') {
		if (toupper(argv[arg+1][1]) == 'Q')
			quiet = 1;
		else if (toupper(argv[arg+1][1]) == 'C')
			cache = 0;
		else if (toupper(argv[arg+1][1]) == 'S') {
			if (argv[arg+1][2])
				minsize = atol(argv[arg+1]+2);
			else
				minsize = 0;
		}
		else
			fprintf(stderr,"%s -- Invalid flag has been ignored.\n",argv[arg]);
		++arg;
	}

//  are there any more arguments	
	if ((arg+1) >= argc) {
		// no
		if (minsize | !quiet | !cache)
			strcpy(inputfile,"."); //start at current directory
	}
	else
		strcpy(inputfile,argv[arg+1]);
	
	if (argc > (2+arg))
		bufsi = atoi(argv[arg+2]);
	else
		bufsi = 0;

	if (argc > (arg+3))
		max_errors = atoi(argv[arg+3]);

	if (argc > (arg+4))
		readKB = _atoi64(argv[arg+4]);

	if (argc > (arg+5))
		rateKB = atol(argv[arg+5]);

	if (argc > (arg+6))
		ratedist = atol(argv[arg+6]);

	if (bufsi == 0 || bufsi > 65535)
		bufsi = BUFSIZE;
	else if (bufsi >= 1 && bufsi <= 63)
		bufsi *= 1024;

	printf("Buffer Size = %u Bytes, Allow %d Errors.\n",bufsi,max_errors);
	if ((buffer = (char *)malloc(bufsi)) == NULL) {
		fprintf(stderr,"Insufficient Memory\n");
		exit(1);
	}

	if (cache) {
		if (inputfile[1] == ':') {
			strncpy(tmp,argv[arg+1],2);
			tmp[2] = 0;
		}
		else {
			tmp[0] = '@'+_getdrive();
			tmp[1] = ':';
			tmp[2] = 0;
		}
		driveType = GetDriveType(tmp);
		if (driveType == DRIVE_CDROM)
			cache = 0;
	}

//	strcpy(inputfile,argv[arg+1]);
	rc = _stati64(inputfile,&statbuf);
//	sprintf(debugbuf,"statbuf.st_mode = %x. _S_IFDIR = %x. IFDIRBIT = %x",
//		statbuf.st_mode, _S_IFDIR, statbuf.st_mode & _S_IFDIR);
	strcpy(tempfiletemplate,"XFER32XXXXX");
    if (rc == 0 && (statbuf.st_mode & _S_IFDIR) && minsize>0 ) {
		// Search for the first file in the specified path that is >=minsize
		strcpy(fn,tempfiletemplate);
		_mktemp(fn);
		sprintf(cmdline,"search32 %s * -s%ld -f -1 -Q >%s 2>nul",argv[arg+1],minsize,fn);
		rc = system(cmdline);
		switch(rc) {
			case -1:
				// Can't find file
				fprintf(stderr,"SEARCH32 is not available.  Unable to scan path for files.\n");
				exit(8);
			case 0:
				// Success, found a file
				fi = fopen(fn,"r");
				if (fi == NULL) {
					fprintf(stderr,"Unable to open temporary file: %s\n",fn);
					exit(8);
				}
				if (fgets(inputfile,sizeof(inputfile),fi) == NULL) {
					fprintf(stderr,"Unable to read temporary file: %s\n",fn);
					fclose(fi);
					exit(8);
				}
				fclose(fi);
				inputfile[strlen(inputfile)-1] = 0;
				fprintf(stderr,"%s\n",inputfile);
				statbuf.st_mode = 0;
				unlink(fn);
				break;
			default:
				fprintf(stderr,"Could not find any files in %s with size larger than %ld\n",inputfile,minsize);
				exit(8);
		}
	}

	if (rc == -1 || (statbuf.st_mode & _S_IFDIR)) {
		// Initialize OPENFILENAME
		ZeroMemory(&ofn, sizeof(OPENFILENAME));
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = hwnd;
		ofn.lpstrFile = szFile;
		ofn.nMaxFile = sizeof(szFile);
		ofn.lpstrFilter = NULL;
		ofn.nFilterIndex = 0;
		ofn.lpstrFileTitle = NULL;
		ofn.nMaxFileTitle = 0;
		ofn.lpstrInitialDir = NULL;
		if (statbuf.st_mode & _S_IFDIR)
			ofn.lpstrInitialDir = argv[arg+1];
		ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

		// Display the Open dialog box. 
//		fprintf(stderr,"BufferSize = %u\n",bufsi);
		CommonDialogError =GetOpenFileName(&ofn);
		if (CommonDialogError == TRUE) {
			fprintf(stderr,"%s\n",ofn.lpstrFile);
			startopen = timeGetTime();
//			fprintf(stderr,"BufferSize = %u\n",bufsi);
			in = CreateFile(ofn.lpstrFile, GENERIC_READ,
			FILE_SHARE_READ, (LPSECURITY_ATTRIBUTES) NULL,
			OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL|cache,
			(HANDLE) NULL);
//			fprintf(stderr,"BufferSize = %u\n",bufsi);
		}
		else {
			// User cancelled dialog or a dialgo error occurred

			CommonDialogErrorCode = CommDlgExtendedError();
			DisplayCommonDialogError(CommonDialogErrorCode);
			exit(1);
		}
	}
	else {
		startopen = timeGetTime();
		in = CreateFile(inputfile,GENERIC_READ,
			FILE_SHARE_READ, (LPSECURITY_ATTRIBUTES) NULL,
			OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|cache,
			(HANDLE) NULL);
	}

	if (in == INVALID_HANDLE_VALUE) {
		perror(inputfile);
		exit(1);
	}

//	fprintf(stderr,"BufferSize = %u\n",bufsi);
//	fprintf(stderr,"BufferSize = %u.  readKB = %I64d\n",bufsi,readKB);

	start = time(&start);
	t0 = timeGetTime();
	opentime = t0 - startopen;
	prev = start;
	GetSystemTime(&startnow);
	if (rateKB > 0 && ratedist > 0) {
		// Need a random value so that rateKB is between +/- ratedist
		// Will use the time in milliseconds for this
		ratedist *= startnow.wMilliseconds;
		ratedist /= 1000;
		if (ratedist % 2)
			rateKB += ratedist;
		else
			rateKB -= ratedist;
		if (!quiet) 
			fprintf(stderr,"Read Rate set to %ld\n",rateKB);
	}
	size = 0;
	// If read rate is set to less than buffer size per seconds
	// set buffer down to read rate so that always have at least
	// one read to do
//	fprintf(stderr,"BufferSize = %u.  readKB = %I64d\n",bufsi,readKB);
	if (readKB && bufsi > (readKB * 1024))
		bufsi = (readKB * 1024);
//	fprintf(stderr,"BufferSize = %u\n",bufsi);
	t0 = timeGetTime();
	rc = ReadFile(in,buffer,bufsi,&si,NULL);
	if (rc == 0) {
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf, 0,    NULL );
		// Process any inserts in lpMsgBuf.
		// ...
		// Display the string.
		fprintf(stderr,"Unable to read input for handle: %u.  %s",in,lpMsgBuf);
		fprintf(stderr,"BufferSize = %u, BytesRead = %d\n",bufsi,si);
		// MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
		// Free the buffer.
		LocalFree( lpMsgBuf );
	}

	t1 = timeGetTime();
	GetSystemTime(&start1);

	if (t1 > t0 && rateKB > 0) 
		rest_a_bit(t1-t0,si,rateKB*1024);
	bytes = si;
	more = 1;
	while (more) {
		while (si && error_count <= max_errors && (readKB==0 || size < (readKB*1024))) {
			size += (rc == FALSE ? 0 : si);
			t0 = timeGetTime();
			rc = ReadFile(in,buffer,bufsi,&si,NULL);
			t1 = timeGetTime()+1;
			if ((t1 > t0) && (rateKB > 0)) 
				rest_a_bit(t1-t0,si,rateKB*1024);
			stop = time(&stop);
			if (rc==FALSE) 
				++error_count;
			else {
				if (si == 0) // end of file
					continue;
				if (si < bufsi) 
					++short_blocks;
				if (stop > start && stop > prev && quiet == 0) {
					fprintf(stderr,"\r                                                                        ");
					fprintf(stderr," \rSize=%I64d, Time = %ld, Xfer Rate = %ld",
						size,stop-start,size/(stop-start));
					if (short_blocks)
						fprintf(stderr,", Short Blk = %d",short_blocks);
					if (error_count)
						fprintf(stderr,", Errors = %d",error_count);
					prev = stop;
				}
			}
		}
		if (error_count > max_errors)
			more = 0;	// stop if too many errors
		if (readKB == 0)
			more = 0;	// stop if end of file and reading just 1 file
		if (size >= (readKB*1024))
			more = 0;	// stop if read max number of bytes
		if (more) {	// Reset to start of file and continue reading
			SetFilePointer(in,0L,NULL,FILE_BEGIN); 
			rc = ReadFile(in,buffer,bufsi,&si,NULL);
		}
	}
	size += (rc == FALSE ? 0 : si);
	GetSystemTime(&endnow);
	stop = time(&stop);
	start = startnow.wHour * 360000l + startnow.wMinute * 6000l + startnow.wSecond * 100 + startnow.wMilliseconds/10;
	prev = 360000l * (start1.wHour + (startnow.wHour > start1.wHour ? 24 : 0));
	prev = prev + start1.wMinute * 6000l + start1.wSecond * 100 + start1.wMilliseconds/10;
	stop = 360000l * (endnow.wHour + (startnow.wHour > endnow.wHour ? 24 : 0));
	stop = stop + endnow.wMinute * 6000l + endnow.wSecond * 100 + endnow.wMilliseconds/10;


	if (stop > start) {
		sprintf(thyme,"%2ld",(stop-start)%100);
		if (thyme[0]==' ')
			thyme[0] = '0';

/*        printf("\r                                                                        "); */
		fprintf(stderr,"\n");
		bps = (long)((100.0*(float)(size))/(float)(stop-start));
		comma_delim((_int64)bps,temp_bps,0,0);
		if (strlen(temp_bps) > 8) 
			sprintf(temp_bps,"%.2lfMBS",bps/1000000);
		else
			strcat(temp_bps,"BPS");
		comma_delim(size,temp_size,0,0);
		if (strlen(temp_size) > 8)
			sprintf(temp_size,"%.2lfMB",(double)(size/10000));
		else
			strcat(temp_size,"Bytes");
        printf("Open(ms)=%ld, Size=%sB, Time(Sec)=%ld.%s, Rate = %sBPS\n",
		opentime,tgm(size,temp_size),(stop-start)/100,thyme,tgm(bps,temp_bps));
		
		if (short_blocks > 1) 
        	printf("%d Short Blocks.  ",short_blocks);
        if (error_count)
        	printf("%d Errors",error_count);
        if (short_blocks > 1 || error_count > 0)
	        putchar('\n');
	}
	else
		printf("\nFile too small to time.  Please select a larger file.\n");
	CloseHandle(in);
	exit(0);
}
